<?php

namespace App\Model;
/**
 * Class Project
 * @package App\Model
 * @author Artsiom Malkovich (skype: artmalk)
 */
class Project extends \RedBean_SimpleModel {

    protected $backlinksValues = null;
    protected $domainValues = null;

    public function isBacklinkExists($link) {
        if (is_null($this->backlinksValues)) {
            $this->backlinksValues = array();
            foreach($this->bean->ownBacklinks as $backlink) {
                $this->backlinksValues[] = $backlink->link;
            }
        }
        if (in_array($link, $this->backlinksValues)) {
            return true;
        }
        return false;
    }

    public function isDomainExists($link)
    {
        if (is_null($this->domainValues)) {
            $this->domainValues = array();
            foreach($this->bean->ownBacklinks as $backlink) {
                $this->domainValues[] = \App\Model\Backlink::getHostWithoutWWW($backlink->link);
            }
        }
        if (in_array(\App\Model\Backlink::getHostWithoutWWW($link), $this->domainValues)) {
            return true;
        }
        return false;
    }

    public function newBacklink($link) {
        $this->backlinksValues[] = $link;
        $this->domainValues[] =  \App\Model\Backlink::getHostWithoutWWW($link);
    }

    /**
     * @return NULL|\App\Model\Parser
     */
    public function getLastParser()
    {
        return  \R::findOne('parser', 'projects_id = ? ORDER BY started DESC', array($this->bean->id));

    }

    public function addNotice(\App\Model\Backlink $backlink, $type)
    {

        $notice = \R::dispense('notices');
        $notice->projects_id = $this->bean->id;
        $notice->backlinks_id = $backlink->id;
        $notice->type = $type;
        $notice->link = $backlink->link;
        \R::store($notice);

    }

}